Extensible Provisioning Protocol (EPP) Mapping for DNS Time-To-Live (TTL) values
Gavin Brown
CentralNic Group plc
44 Gutter Lane
London
EC2V 6BR
GB
+44 20 33 88 0600
gavin.brown@centralnic.com
https://www.centralnic.com
14 September 2022
Applications
Registration Protocols Extensions (regext)
This document describes an extension to the Extensible Provisioning Protcol (EPP) that allows EPP clients to manage the Time-To-Live (TTL) value for domain name delegation records.

Introduction
The principal output of any domain name provisioning system is a DNS zone file, which contains the delegation record(s) for names registered within the zone. These records include, at minimum, one or more NS records, but may also include A and/or AAAA glue records, and DS records.
Typically, the Time-To-Live (TTL) of these records is determined by the registry operator. However, in some circumstances it may be desirable to allow the sponsoring registrar of a domain name to change the TTL used for a particular domain: for example, to reduce the amount of time required to complete a change of DNS servers, or a DNSSEC key rollover.
This document describes an EPP extension to the domain name object mapping (described in [RFC5731]) which allows the sponsor of a domain name object to change the TTL associated with a given domain.

Conventions Used in This Document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119].
In examples, "C:" represents lines sent by a protocol client and "S:" represents lines returned by a protocol server. Indentation and white space in examples are provided only to illustrate element relationships and are not REQUIRED features of this protocol. A protocol client that is authorized to manage an existing object is described as a "sponsoring" client throughout this document.
XML is case sensitive. Unless stated otherwise, XML specifications and examples provided in this document MUST be interpreted in the character case presented in order to develop a conforming implementation.

Extension Elements
This specification defines a single new element, <ttl:secs>, which contains a 32-bit unsigned integer indicating the TTL which will be applied to the delegation records for the associated domain name.
Example:
<ttl xmlns="urn:ietf:params:xml:ns:ttl-1.0">3600</ttl>

EPP Command Mapping

EPP Query Commands

EPP <info> Command
This extension defines additional elements EPP <info> responses.
The <info> response MAY contain an <extension>; element which MAY contain a <ttl:infData> element. This element contains a single <ttl:secs> element.
Example <info> response:

S: <?xml version="1.0" encoding="utf-8" standalone="no"?>
S: <epp xmlns="urn:ietf:params:xml:ns:epp-1.0">
S:   <response>
S:     <result code="1000">
S:       <msg>Command completed successfully</msg>
S:     </result>
S:     <resData>
S:       <domain:infData
S:         xmlns:domain="urn:ietf:params:xml:ns:domain-1.0">
S:         <domain:name>example.com</domain:name>
S:         <domain:roid>EXAMPLE1-REP</domain:roid>
S:         <domain:status s="ok" />
S:         <domain:registrant>jd1234</domain:registrant>
S:         <domain:contact type="admin">sh8013</domain:contact>
S:         <domain:contact type="tech">sh8013</domain:contact>
S:         <domain:ns>
S:           <domain:hostObj>ns1.example.com</domain:hostObj>
S:           <domain:hostObj>ns1.example.net</domain:hostObj>
S:         </domain:ns>
S:         <domain:clID>ClientX</domain:clID>
S:         <domain:crID>ClientY</domain:crID>
S:         <domain:crDate>1999-04-03T22:00:00.0Z</domain:crDate>
S:         <domain:upID>ClientX</domain:upID>
S:         <domain:upDate>1999-12-03T09:00:00.0Z</domain:upDate>
S:         <domain:exDate>2005-04-03T22:00:00.0Z</domain:exDate>
S:         <domain:trDate>2000-04-08T09:00:00.0Z</domain:trDate>
S:         <domain:authInfo>
S:           <domain:pw>2fooBAR</domain:pw>
S:         </domain:authInfo>
S:       </domain:infData>
S:     </resData>
S:     <extension>
S:       <ttl:infData
S:         xmlns:ttl="urn:ietf:params:xml:ns:ttl-1.0">
S:         <ttl:secs>3600</ttl:secs>
S:       </ttl:infData>
S:     </extension>
S:     <trID>
S:       <clTRID>ABC-12345</clTRID>
S:       <svTRID>54322-XYZ</svTRID>
S:     </trID>
S:   </response>
S: </epp>

EPP Transform Commands

EPP <create> Command
This extension defines additional elements EPP <create> commands.
The <create> command MAY contain an <extension> element which MAY contain a <ttl:create> element. This element contains a single <ttl:secs> element.
Example <create> command:
C: <?xml version="1.0" encoding="UTF-8" standalone="no"?>
C: <epp xmlns="urn:ietf:params:xml:ns:epp-1.0">
C:   <command>
C:     <create>
C:       <domain:create
C:        xmlns:domain="urn:ietf:params:xml:ns:domain-1.0">
C:         <domain:name>example.com</domain:name>
C:         <domain:period unit="y">2</domain:period>
C:         <domain:ns>
C:           <domain:hostObj>ns1.example.net</domain:hostObj>
C:           <domain:hostObj>ns2.example.net</domain:hostObj>
C:         </domain:ns>
C:         <domain:registrant>jd1234</domain:registrant>
C:         <domain:contact type="admin">sh8013</domain:contact>
C:         <domain:contact type="tech">sh8013</domain:contact>
C:         <domain:authInfo>
C:           <domain:pw>2fooBAR</domain:pw>
C:         </domain:authInfo>
C:       </domain:create>
C:     </create>
C:     <extension>
C:       <ttl:create
C:         xmlns:ttl="urn:ietf:params:xml:ns:ttl-1.0">
C:         <ttl:secs>3600</ttl:secs>
C:       </ttl:create>
C:     </extension>
C:     <clTRID>ABC-12345</clTRID>
C:   </command>
C: </epp>

EPP <update> Command
This extension defines additional elements EPP <update> commands.
The <update> command MAY contain an <extension> element which MAY contain a <ttl:update> element. This element contains a single <ttl:secs> element.
Example <update> command:

C:<?xml version="1.0" encoding="UTF-8" standalone="no"?>
C:<epp xmlns="urn:ietf:params:xml:ns:epp-1.0"
C:     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
C:  <command>
C:    <update>
C:      <domain:update
C:       xmlns:domain="urn:ietf:params:xml:ns:domain-1.0">
C:        <domain:name>example.com</domain:name>
C:      </domain:update>
C:    </update>
C:    <extension>
C:       <ttl:update>
C:         xmlns:ttl="urn:ietf:params:xml:ns:ttl-1.0">
C:         <ttl:secs>3600</ttl:secs>
C:       </ttl:update>
C:     </extension>
C:    <clTRID>ABC-12345</clTRID>
C:  </command>
C:</epp>

Server Processing of TTL Values
EPP servers which implement this extension SHOULD use the values provided by EPP clients for the TTL values of NS, A, AAAA and DS records published in the DNS for the corresponding delegation.
If an EPP server receives a command containing a TTL that is outside the server's permitted range (see Operational Considerations and Security Considerations below), it MUST reject the command with a 2004 "Parameter value range error" response.

Out-of-band changes to TTL values
EPP server operators MAY, in order to address operational or security issues, make changes to domain TTL values out-of-band (that is, not in response to an <update> command received from the domain's sponsor).
Additionally, server operators may implement an automatic reset of TTL values, so that they may be changed for a finite period before and after a planned change, and then revert to a standard value.
In the event of changes to TTL values taking place out-of-band, EPP server operators SHOULD notify the sponsoring client by means of the EPP message queue and/or the EPP Change Poll Extension ([RFC8590]).

Operational Considerations

Operational impact of TTL values
Domain registry operators must strike a balance between, on the one hand, the desire of registrants for changes to their domains to be visible in the DNS quickly, and the increased DNS query traffic that short TTLs can bring. Historically, registry operators specified a global TTL value that applies to all delegations within their zones, which has made it relatively easy to tune this value to an optimum value.
Domain registry operators SHOULD implement limits on the maximum and minimum TTL values (that are narrower than the values permitted in the Formal Specification, which were chosen to allow any TTL permitted in DNS records), to prevent scenarios where an excessively high or low TTL causes operational issues on either side of the zone cut.

When the TTL should be changed
A common operational mistake is changing of DNS record TTLs during or after the planned change to the records themselves. This arises due to a misunderstanding about how TTLs work.
Client implementations of this specification SHOULD ensure that the user understands that changes to a TTL are only effective in shortening transition periods if implemented a period of time — at least equal to the current TTL — before the planned change.

Security Considerations
Many malicious actors use a technique called "fast flux DNS" to rapidly change the DNS configuration for a zone in order to evade takedown and law enforcement activity.
Registry operators should take this into consideration when setting the lower limit on TTL values, since a short TTL on delegations has the potential to enhance the effectiveness of fast flux techniques on evasion.

IANA Considerations

XML Namespace
This document uses URNs to describe XML namespaces and XML schemas conforming to a registry mechanism described in [RFC3688]. The following URI assignment has been made by IANA:
Registration for the TTL namespace:
URI: urn:ietf:params:xml:ns:ttl-1.0
Registrant Contact: See the author of this document
XML: None. Namespace URIs do not represent an XML specification
Registration for the TTL XML schema:
URI: urn:ietf:params:xml:ns:ttl-1.0
Registrant Contact: See the author of this document
XML: See the "Formal Syntax" section of this document

EPP Extension Registry
The EPP extension described in this document has been registered by the IANA in the Extensions for the "Extensible Provisioning Protocol (EPP)" registry described in [RFC7451]. The details of the registration are as follows:
Name of Extension: Extensible Provisioning Protocol (EPP) Mapping for DNS Time-To-Live (TTL) values
Document Status: Experimental
Reference: URL of this document
Registrant Name and Email Address: See the author of this document
TLDs: Any
IPR Disclosure: None
Status: Active
Notes: None

Formal Specification
<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns:ttl="urn:ietf:params:xml:ns:ttl-1.0">
  <annotation>
    <documentation>
      Extensible Provisioning Protocol v1.0 domain name
      extension schema for Time-To-Live (TTL) modification
      in all DNS responses for a domain name including
      delegation (NS) records and any address (A) records.
    </documentation>
  </annotation>

  <!-- Child elements found in EPP commands -->
  <element name="create" type="ttl:secs"/>
  <element name="update" type="ttl:secs"/>

  <!-- Child elements found in EPP responses -->
  <element name="infData" type="ttl:secs"/>

  <complexType name="secs">
    <sequence>
      <element name="secs" type="ttl:nonNegativeInteger"/>
    </sequence>
  </complexType>

  <simpleType name="nonNegativeInteger">
    <restriction base="nonNegativeInteger">
      <minInclusive value="1"/>
      <maxInclusive value="4294967295"/>
    </restriction>
  </simpleType>
</schema>

Normative References
[RFC5731]
[RFC2119]
[RFC8590]
[RFC3688]
[RFC7451]